__rcs_id__='$Id: Logger.py,v 1.1 1999/10/11 04:08:21 zen Exp zen $'
__version__='$Revision: 1.1 $'[11:-2]

from DocumentTemplate.DT_Util import *
from DocumentTemplate.DT_String import String
import string
import zLOG

LoggerError = "Log Tag Error"

# Perhaps this map should be moved to zLog.py? 
severities = {
    'BLATHER':	zLOG.BLATHER, 
    'INFO': 	zLOG.INFO,
    'PROBLEM':	zLOG.PROBLEM,
    'ERROR':	zLOG.ERROR,
    'PANIC':	zLOG.PANIC,
    }

invalidseverity = 'Invalid Severity'

class LogTag:
    '''Send a message to Zope's logging system. See README.txt for
       details.'''

    name='log'
    blockContinuations=('logdetail',)

    def __init__(self, blocks):

	tname, args, section = blocks[0]

	args = parse_params(args, severity=None, subsystem=None)

	has_key=args.has_key

	if not has_key('severity'): 
	    args['severity'] = 'INFO'
	else:
	    args['severity'] = string.upper(args['severity'])
	    if not severities.has_key(args['severity']):
		raise invalidseverity, (
		    'An invalid severity (%s) was given' % args['severity'])

	if not has_key('subsystem'):
	    args['subsystem'] = 'DTML'

	self.args = args
	self.sectionSummary = section

	if len(blocks) > 1:
	    self.sectionDetail = blocks[1][2]
	else:
	    self.sectionDetail = None

    def render(self,md):
	subsystem = self.args['subsystem']
	severity  = severities[self.args['severity']]
	summary = self.sectionSummary(md.this,md)
	detail = ''
	if self.sectionDetail is not None:
	    detail = self.sectionDetail(md.this,md)
	zLOG.LOG(subsystem,severity,summary,detail)

	return ' '

    __call__ = render

String.commands['log'] = LogTag

